moGuiExtras = {};

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;
function moGuiExtras:setFirstDisplayZoom(self)
	if moDefault.mapStations > 14 then moSetGetGui.zoomOutMax = moSetGetGui.zoomInMax;return;end;
	local checkZoom = moSetGetGui.zoomOutMax;
	for i = moSetGetGui.zoomInMax, checkZoom, 0.001 do
		if moGuiExtras:setMaxDisplayZoom(self) then			
			if moSetGetGui.pdaMenueSize > moSetGetGui.zoomOutMax then
				moSetGetGui.pdaMenueSize = moSetGetGui.zoomOutMax;
			end;
			if moSetGetGui.pdaMenueSize < moSetGetGui.zoomInMax then
				moSetGetGui.pdaMenueSize = moSetGetGui.zoomInMax;
			end;
			break;
		end;
	end;
end;

function moGuiExtras:setMaxDisplayZoom(self)
	local posBFruit = moSetGetGui.zoomOutMax/3*(moDefault.lengthFruitName)*1.03;
	local posBAmount = moSetGetGui.zoomOutMax/3*(moDefault.lengthAmount)*1.03;
	local posBStation = moSetGetGui.zoomOutMax/3*(moDefault.lengthStation)*1.03;
	local maxDisplay = 0.232+posBFruit+posBAmount+posBStation;
	local display = moSetGetGui.lsSpeedHudX+0.175; --1.00 !!!
	if maxDisplay > display then		
		moSetGetGui.zoomOutMax = moSetGetGui.zoomOutMax-0.001;		
		if tonumber(moSetGetGui.zoomOutMax) == tonumber(moSetGetGui.zoomInMax) then return true;end;
		return false;		
	end;
	return true;
end;

function moGuiExtras:setScreenAspectRatio(self)
	if g_screenAspectRatio >= 1.3 and g_screenAspectRatio <= 1.4 then moSetGetGui.screenAspectRatio = 2.3;end;
	if g_screenAspectRatio >= 1.25 and g_screenAspectRatio <= 1.29 then moSetGetGui.screenAspectRatio = 2.4;end;
	if g_screenAspectRatio >= 1.6 and g_screenAspectRatio <= 1.7 then moSetGetGui.screenAspectRatio = 1.2;end;
	if g_screenAspectRatio >= 1.7 then moSetGetGui.screenAspectRatio = 0;end;
end;

function moGuiExtras:getMoneyFormat(price)
	--if string.len(price) >= 8 then
	--	local splitPrice = Utils.splitString(".", price);
	--	if splitPrice ~= nil and splitPrice[1] ~= nil and splitPrice[2] ~= nil then
	--		return ((splitPrice[1]/1000).. ".".. splitPrice[2]);
	--	end;
	--end;
	--g_i18n:formatMoney(price);
	if string.len(price) >= 8 then
		local replacePrice1 = string.sub (price, string.len(price)-6);		
		local replacePrice2 = string.sub (price, 0, string.len(price)-7);		
		return (replacePrice2.. ".".. replacePrice1);
	end;
	return price;
end;

function moGuiExtras:getMilliSecondsToHours(sMilliSeconds, getHoursMin, getHoursSec)
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == nil or nMilliSeconds == 0 then	
		return "0";
	else
		local nHours = string.format("%02.f", floor(nMilliSeconds/3600000));
		local nMins = string.format("%02.f", floor(nMilliSeconds/60000 - (nHours*60)));	
		local nSecs = string.format("%02.f", floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));
		if not getHoursMin then return nHours;end;				
		if getHoursMin and getHoursSec == nil then return nHours..":"..nMins;end;
		if getHoursMin and getHoursSec then return nHours..":"..nMins..":"..nSecs;end;
	end;
	return "0";
end;

function moGuiExtras:getRealTime(getHours, getMin, getSec)
	if getHours and not getMin and not getSec then return tostring(getDate("%H"));end;
	if getHours and getMin and not getSec then return tostring(getDate("%H:%M"));end;
	if getHours and getMin and getSec then return tostring(getDate("%H:%M:%S"));end;
	return "0";
end;

function moGuiExtras:getRandomColor(wert1, wert2)
	return random(wert1, wert2), random(wert1, wert2), random(wert1, wert2);
end;

function moGuiExtras:setSlotPositionenDouble(self, slot, plus)	
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local lastWidth = moGuiMiniPdaSlots.values[slot].openLastWidth;	
	if plus then
		if moGuiMiniPdaSlots.values[slot].openX+(slotLength-0.003)+lastWidth > 1.0 then
			moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.values[slot].openX-(slotLength-0.003);			
		end;
		moGuiMiniPdaSlots.values[slot].openLastWidth = lastWidth+(slotLength+distanceDif);
	else
		--if moGuiMiniPdaSlots.values[slot].openX+lastWidth < 1.0 then
			--moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.values[slot].openX+(slotLength-0.003);
			moGuiMiniPdaSlots.values[slot].openLastWidth = lastWidth-(slotLength+distanceDif);
		--end;
	end;	
	moMouseClickAreas:setSlotCfg(self, slot);
end;

function moGuiExtras:setSlotPositionen(self, slot, new)	
	local slotName = MultiOverlayV2:getSlotName(slot);
	local widthNext = 0;
	local size = moGuiMiniPdaSlots.values[slot].size;
	if slotName == "bestprice" then widthNext = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGeneralSettings.lengthStationName+moSetGetGui.screenAspectRatio);end;	
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	moGuiMiniPdaSlots.values[slot].openLastWidth = slotLength+distanceDif+widthNext;		
	if new then		
		moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.defaultOpenX;
		if moGuiMiniPdaSlots.values[slot].openX > 0.5 then 
			moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.defaultOpenX-slotLength-0.003-widthNext;
			if slotName == "fieldsprice" then moGuiMiniPdaSlots.values[slot].maxProSwitch = 20;end;
		end;
		moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.defaultOpenY;
	else
		--if moGuiMiniPdaSlots.values[slot].openX > 0.5 then moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.defaultOpenX-slotLength;end;
	end;
	moMouseClickAreas:setSlotCfg(self, slot);
end;

function moGuiExtras:setSlotMaxProSwitch(self, slot)
	local objects = 0;
	if moGuiMiniPdaSlots.values[slot].name == "fieldsinfo" then
		if moGuiMiniPdaSlots.fieldsInfo.textSwitch == 0 or moGuiMiniPdaSlots.fieldsInfo.iconSwitch == 0 then  
			if moGuiMiniPdaSlots.values[slot].maxProSwitch < 50 then 
				moGuiMiniPdaSlots.values[slot].maxProSwitch = 50;
			end;
			objects = moGuiMiniPdaSlots.values[slot].foundObjects/moGuiMiniPdaSlots.values[slot].maxProSwitch;
		else
			if moGuiMiniPdaSlots.values[slot].maxProSwitch > 40 then moGuiMiniPdaSlots.values[slot].maxProSwitch = 4;end;
			objects = moGuiMiniPdaSlots.values[slot].foundObjects/moGuiMiniPdaSlots.values[slot].maxProSwitch;
		end;
	else
		objects = moGuiMiniPdaSlots.values[slot].foundObjects/moGuiMiniPdaSlots.values[slot].maxProSwitch;
	end;
	local maxSwitch = moSetGetGui:round(objects+0.5);	
	if maxSwitch <= 1 then maxSwitch = 1;end;
	moGuiMiniPdaSlots.values[slot].maxSwitch = maxSwitch;	
	if moGuiMiniPdaSlots.values[slot].switch > maxSwitch then moGuiMiniPdaSlots.values[slot].switch = 1;end;	
end;

function moGuiExtras:setSlotFirstEndObjects(self, slot)	
	if moGuiMiniPdaSlots.values[slot].switch == 1 then moGuiMiniPdaSlots.values[slot].firstObject = 1;moGuiMiniPdaSlots.values[slot].endObject = moGuiMiniPdaSlots.values[slot].maxProSwitch;end;
	if moGuiMiniPdaSlots.values[slot].switch > 1 then moGuiMiniPdaSlots.values[slot].firstObject = (moGuiMiniPdaSlots.values[slot].switch-1)*moGuiMiniPdaSlots.values[slot].maxProSwitch+(1);moGuiMiniPdaSlots.values[slot].endObject = moGuiMiniPdaSlots.values[slot].switch*moGuiMiniPdaSlots.values[slot].maxProSwitch;end;
	if moGuiMiniPdaSlots.values[slot].endObject > moGuiMiniPdaSlots.values[slot].foundObjects then moGuiMiniPdaSlots.values[slot].endObject = moGuiMiniPdaSlots.values[slot].foundObjects;end;	
end;

function moGuiExtras:closeOpenSlot(self, slot, close, open)
	moGuiMiniPdaSlots.isSeeSmallDraw = false;							
	moGuiMiniPdaSlots.seeSmallDrawEnd = 350;
	if close and not open and moGuiMiniPdaSlots.values[slot].isOpen then		
		if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, false);end;
		if moGuiMiniPdaSlots.values[slot].closeOpenHud then 
			moGuiMiniPdaSlots.values[slot].isOpen = false;
			if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, false);end;
		end;
		return;
	end;
	if not close and open and not moGuiMiniPdaSlots.values[slot].isOpen then
		moGuiMiniPdaSlots.values[slot].isOpen = true;
		MultiOverlayV2:setSlotUpdate(self, slot);
		if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, true);end;		
		if moGuiMiniPdaSlots.values[slot].closeOpenHud then			
			if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, true);end;
		end;
		return;
	end;
	if close and open then
		if moGuiMiniPdaSlots.values[slot].isOpen then
			if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, false);end;
			if moGuiMiniPdaSlots.values[slot].closeOpenHud then 
				moGuiMiniPdaSlots.values[slot].isOpen = false;
				if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, false);end;
			end;
			return;			
		else
			moGuiMiniPdaSlots.values[slot].isOpen = true;
			MultiOverlayV2:setSlotUpdate(self, slot);
			if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, true);end;			
			if moGuiMiniPdaSlots.values[slot].closeOpenHud then 				
				if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, true);end;
			end;
			return;			
		end;
	end;
end;

function moGuiExtras:setGetCloseAllHud(self, slot, disable)	
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	local helpText = moSetGetGui.helpText;
	local miniMap = moSetGetGui.miniMap.on;
	local wtmHud = moSetGetGui.wtmHud.on;
	local mohHud = moSetGetGui.wtmHud.mohHud;	
	local vsHud = moSetGetGui.vsHud.on;
	if disable then
		if helpText then moGuiExtras:setGetHelpText(self, false);end;		
		if miniMap then moGuiExtras:setGetMiniMap(self, false);end;		
		if wtmHud then moGuiExtras:setGetWtmHud(self, false);end;		
		if vsHud then moGuiExtras:setGetVsHud(self, false);end;
		if mohHud then moGuiExtras:setGetWtmMohHud(self, false);end;
		if slot ~= nil and slot ~= 0 then
			moGuiMiniPdaSlots.values[slot].closeAllHudTemp = {helpText, miniMap, wtmHud, vsHud, mohHud};
		else
			moSetGetGui.closeAllHudTemp = {helpText, miniMap, wtmHud, vsHud, mohHud};
		end;
	else
		if moSetGetGui.closeAllHudTemp[1] then moGuiExtras:setGetHelpText(self, true);end;
		if moSetGetGui.closeAllHudTemp[2] then moGuiExtras:setGetMiniMap(self, true);end;
		if moSetGetGui.closeAllHudTemp[3] then moGuiExtras:setGetWtmHud(self, true);end;
		if moSetGetGui.closeAllHudTemp[4] then moGuiExtras:setGetVsHud(self, true);end;
		if moSetGetGui.closeAllHudTemp[5] then moGuiExtras:setGetWtmMohHud(self, true);end;
		if slot ~= nil and slot ~= 0 then
			moGuiMiniPdaSlots.values[slot].closeAllHudTemp = {true, true, true, true, true};			
		else
			moSetGetGui.closeAllHudTemp = {true, true, true, true, true};
		end;
	end;
end;

function moGuiExtras:setGetHelpText(self, enable)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	if enable then 
		g_gameSettings:setValue("showHelpMenu", true);
		--g_currentMission.showHelpText = true;
		moSetGetGui.helpText = true;
	else
		--g_currentMission.showHelpText = false;
		g_gameSettings:setValue("showHelpMenu", false);
		moSetGetGui.helpText = false;
	end;
end;

function moGuiExtras:setGetMiniMap(self, enable)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	if moSetGetGui.miniMap.binding then
		if enable then
			g_currentMission.ingameMap.isVisible = true;
			moSetGetGui.miniMap.on = true;
		else
			g_currentMission.ingameMap.isVisible = false;
			moSetGetGui.miniMap.on = false;
		end;
	end;
end;

function moGuiExtras:setGetWtmHudTest(self, enable)
	--ls17
	local ls17 = false;
	if not ls17 then return;end;
	if moSetGetGui.wtmHud.binding then
		if enable then			
			if moSetGetGui.wtmHud.mohHud then return;end;
			moSetGetGui.wtmHud.on = true;
			g_currentMission.moneyBackgroundOverlay.visible = true;
			g_currentMission.moneyIconOverlay.visible = true;
			if moSetGetGui.wtmHud.moneyTextSize <= 0 then moSetGetGui.wtmHud.moneyTextSize = 0.015750000234693;end;
			if moSetGetGui.wtmHud.timeTextSize <= 0 then moSetGetGui.wtmHud.timeTextSize = 0.029166667101284;end;
			if moSetGetGui.wtmHud.timeScaleTextSize <= 0 then moSetGetGui.wtmHud.timeScaleTextSize = 0.010500000156462;end;
			g_currentMission.moneyTextSize = moSetGetGui.wtmHud.moneyTextSize;
			g_currentMission.timeTextSize = moSetGetGui.wtmHud.timeTextSize;
			g_currentMission.timeScaleTextSize = moSetGetGui.wtmHud.timeScaleTextSize;
			g_currentMission.timeScaleIconOverlay.visible = true;
			g_currentMission.timeScaleOverlay.visible = true;
			g_currentMission.missionStatusTimeOverlay.visible = true;
			--g_currentMission.renderTime = true;
			g_currentMission.showWeatherForecast = true;						
		else						
			moSetGetGui.wtmHud.on = false;		
			--g_currentMission.renderTime = false;
			g_currentMission.moneyIconOverlay.visible = false;		
			g_currentMission.moneyTextSize = 0.0;
			g_currentMission.timeTextSize = 0.0;
			g_currentMission.timeScaleTextSize = 0.0;
			g_currentMission.missionStatusTimeOverlay.visible = false;
			g_currentMission.timeScaleOverlay.visible = false;
			g_currentMission.timeScaleIconOverlay.visible = false;
			g_currentMission.moneyBackgroundOverlay.visible = false;
			g_currentMission.showWeatherForecast = false;
			--g_currentMission.timeScaleOverlay
			--g_currentMission.timeTextSize......0.029166667101284
			--g_currentMission.timeScaleIconOverlay
			--g_currentMission.missionStatusTimeOverlay
			--g_currentMission.timeScaleTextSize......0.010500000156462
		end;
	end;
end;

function moGuiExtras:setGetWtmHud(self, enable)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	if moSetGetGui.wtmHud.binding then
		if enable then			
			if moSetGetGui.wtmHud.mohHud then return;end;
			moSetGetGui.wtmHud.on = true;
			g_currentMission.mohWtmHud = false;
			g_currentMission.mohWtmHudisHiden = false;
			--g_currentMission.moneyBackgroundOverlay.visible = true;
			g_currentMission.infoBarBgOverlay.visible = true; --infoBarBgOverlay,operatingTimeOverlay,timeIconOverlay,timeBgOverlay,timeScaleIconOverlay,fieldJobTimeBgOverlay,weatherForecastBgOverlay,showHudEnv,showHudMissionBase,timeScaleArrowOverlay,timeScaleIconOverlay,tutorialBgOverlay
			g_currentMission.moneyIconOverlay.visible = true;
			if moSetGetGui.wtmHud.moneyTextSize <= 0 then moSetGetGui.wtmHud.moneyTextSize = 0.015750000234693;end;
			g_currentMission.moneyTextSize = moSetGetGui.wtmHud.moneyTextSize;		
			g_currentMission.renderTime = true;
			g_currentMission.showWeatherForecast = true;
			if g_seasons ~= nil and g_seasons.forecast ~= nil and g_seasons.forecast.hud ~= nil then				
				if not Utils.getNoNil(g_currentMission.fieldJobManager.currentFieldJob, false) then
					if moSetGetGui.wtmHud.seasonsMod.visible then g_seasons.forecast.hud.visible = true;end;
					g_seasons.forecast.hud.textSize = g_currentMission.timeScaleTextSize;					
					g_seasons.forecast.hud.dayHeight = moSetGetGui.wtmHud.seasonsMod.dayHeight;
					g_seasons.forecast.hud.dayWidth = moSetGetGui.wtmHud.seasonsMod.dayWidth;
					g_seasons.forecast.hud.iconWidthSmall = moSetGetGui.wtmHud.seasonsMod.iconWidthSmall;
					g_seasons.forecast.hud.iconHeightSmall = moSetGetGui.wtmHud.seasonsMod.iconHeightSmall;					
				end;
			end;
		else						
			moSetGetGui.wtmHud.on = false;
			g_currentMission.mohWtmHud = true;
			g_currentMission.renderTime = false;
			g_currentMission.moneyIconOverlay.visible = false;		
			g_currentMission.moneyTextSize = 0.0;
			--g_currentMission.moneyBackgroundOverlay.visible = false;
			g_currentMission.infoBarBgOverlay.visible = false;
			g_currentMission.showWeatherForecast = false;
			if g_seasons ~= nil and g_seasons.forecast ~= nil and g_seasons.forecast.hud ~= nil then
				if not Utils.getNoNil(g_currentMission.fieldJobManager.currentFieldJob, false) then
					if g_seasons.forecast.hud.visible then
						moSetGetGui.wtmHud.seasonsMod.visible = g_seasons.forecast.hud.visible;
						g_seasons.forecast.hud.visible = false;
					end;
					g_seasons.forecast.hud.textSize = 0;
					g_seasons.forecast.hud.dayHeight = 0;
					g_seasons.forecast.hud.dayWidth = 0;
					g_seasons.forecast.hud.iconWidthSmall = 0;
					g_seasons.forecast.hud.iconHeightSmall = 0;					
				end;
			end;
		end;
	end;
end;

function moGuiExtras:setGetWtmMohHud(self, enable)
	if moSetGetGui.wtmHud.binding then
		if enable then
			moSetGetGui.wtmHud.isHiden = false;
			g_currentMission.mohWtmHudisHiden = false;
		else
			moSetGetGui.wtmHud.isHiden = true;
			g_currentMission.mohWtmHudisHiden = true;
		end;
	end;
end;

function moGuiExtras:setGetVsHud(self, enable)
	if moSetGetGui.vsHud.binding then
		if enable then
			g_currentMission.showVehicleSchema = true;
			g_currentMission.showVehicleInfo = true;
			--g_currentMission.showTriggerMarker = true;
			moSetGetGui.vsHud.on = true;
		else
			g_currentMission.showVehicleSchema= false;
			g_currentMission.showVehicleInfo = false;
			--g_currentMission.showTriggerMarker = false;
			moSetGetGui.vsHud.on = false;
		end;
	end;
end;
--vehicleSchemaOverlayScaleY
--vehicleXZPosCompressionParams table
--vehicleYPosCompressionParams table
--vehicleSellingPointBase table
--vehicleHudPosY
--vehicleBaseHudWidth
--vehicleSchemaOverlayScaleX
--vehicleBaseHudHeight
--vehicleHudScale
--vehicleHudPosX
--speedHudPosY
--speedUnitTextPosY
--speedTextPosX
--speedUnitTextPosX
--speedTextPosY
--speedHudPosX
--speedUnitTextSize
--speedHud table
--speedTextSize

function moGuiExtras:disableMboBuyShowGui(self)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	if moSetGetGui.page[2].mboBuyShowObject ~= nil then
		moSetGetGui.page[2].mboBuyShowObject.count = 0;
		moSetGetGui.page[2].mboBuyShowObject.playerInTrigger = false;
		moSetGetGui.page[2].mboBuyShowObject.timerPreview = 0;
		--moSetGetGui.page[2].mboBuyShowObject.startTimer = false;		
		--moSetGetGui.page[2].mboBuyShowObject.infoToOthersHUD = false;
		--stopSample(moSetGetGui.page[2].mboBuyShowObject.previewSound);
		--stopSample(moSetGetGui.page[2].mboBuyShowObject.mapSound);
		--moSetGetGui.page[2].mboBuyShowObject.soundPreview = false;
		--moSetGetGui.page[2].mboBuyShowObject.playing = false;
		if moSetGetGui.page[2].mboBuyShowObject.pdaState == 1 then
			g_currentMission.ingameMap.isVisible = true;
			moSetGetGui.page[2].mboBuyShowObject.pdaState = 0;
		end;
		if moSetGetGui.page[2].mboBuyShowObject.helpHudState == 1 then
			g_currentMission.showHelpText = true;
			moSetGetGui.page[2].mboBuyShowObject.helpHudState = 0;
		end;
		moSetGetGui.page[2].mboBuyShowObject = nil;
	end;
	moSetGetGui.page[2].mboBuyShowGui = false;
	moSetGetGui.page[2].mboBuyShowTimer = 0;
	moSetGetGui.page[2].isHiden = false;
end;

function moGuiExtras:writeLogObjects(self)
	print("----".. tostring(MultiOverlayV2.metadata.title).. " logSearchMap Objects----")
	print(" found Register animals(sr/ls): ".. tostring(moGeneralSettings.foundAnimals))
	print(" found Map animals(sr/ls): ".. tostring(moGeneralSettings.foundAnimalsLog))
	print(" found other: ".. tostring(moGeneralSettings.foundOther))
	print(" found fs: ".. tostring(moGeneralSettings.foundFabrikscript))
	print(" found cf: ".. tostring(moGeneralSettings.foundCompanyFactory))
	if moGeneralSettings.upkReady then print(" found upk: ".. tostring(moGeneralSettings.foundUpk));end;
	print(" Bsp: <map>...<modType=fs slotType=factory2 xmlString=kompostier_anlage category=factory separated=true displayName=Compost>")
	print(" Bsp: optional values---> 1.category 2.separated 3.displayName (default 1.factory 2.true 3.xmlString)")
	print(" found mapscripts: ".. tostring(moGeneralSettings.foundScripts))
	if moGeneralSettings.notFoundPalSammler ~= 0 then
		print(" !! ".. tostring(moGeneralSettings.notFoundPalSammler.. " PalSammler not assigned !!"))
	end;
	local count = 0;
	local logTxt = "";
	if moStationes ~= nil then
		print(" --optional replace StationNames at language_...xml - <text name=station_StationBiomassHeatingPlant text=Bio Hz. />")		
		for k,v in pairs(moStationes) do
			count = count+1;			
			local stationName = moStationes[k].station;
			if string.find(stationName, " ") then
				stationName = string.gsub(stationName, " ", "_");
			end;
			logTxt = logTxt.. stationName.. "(inGame:".. moStationes[k].stationName.. "),"
			if count == 5 then
				print(" found MapStationes: ".. tostring(logTxt))
				logTxt = "";
				count = 0;
			end;
		end;
		if string.len(logTxt) > 0 then
			print(" found MapStationes: ".. tostring(logTxt))
		end;
	end;
	logTxt = "";
	count = 0;
	if moFillTypes ~= nil then
		print(" --optional replace FruitNames at language_...xml - <text name=fruit_maize text=Mais />")
		for k,v in pairs(moFillTypes) do
			count = count+1;
			local fruitName = moFillTypes[k].descName;
			if string.find(fruitName, " ") then
				fruitName = string.gsub(fruitName, " ", "_");
			end;
			logTxt = logTxt.. fruitName.. "(inGame:".. moFillTypes[k].fruitName.. "),"
			if count == 8 then
				print(" found MapFruits: ".. tostring(logTxt))
				logTxt = "";
				count = 0;
			end;
		end;
		if string.len(logTxt) > 0 then
			print(" found MapFruits: ".. tostring(logTxt))
		end;
	end;
	
end;

function moGuiExtras:fruitNamesOnLoad(self)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	moSetGetGui.vsHud.fsBaseMission = true;
	FSBaseMission.drawHudIcon = Utils.prependedFunction(FSBaseMission.drawHudIcon, function(self)
		if moSetGetGui.vsHud.fruitNamesOn and g_currentMission.controlledVehicle ~= nil then
			--renderText(g_currentMission.fillLevel1Bar.x, g_currentMission.fillLevel1Bar.y+(g_currentMission.fillLevel1Bar.height), moSetGetGui.vsHud.fruitNameSize, "---".. tostring(g_userNickname).. "---");
			local vehiclesLength = 0; --table.getn(g_currentMission.steerables);			
			local vehicle = nil;
			local isControlled = Utils.getNoNil(g_currentMission.controlledVehicle.isControlled, false);
			local controllerName = Utils.getNoNil(g_currentMission.controlledVehicle.controllerName, "");
			if isControlled and controllerName == g_currentMission.player.controllerName then
				vehicle = g_currentMission.controlledVehicle;
			end;
			if vehiclesLength > 0 then 
				for a=1, vehiclesLength do 
					vehicle = g_currentMission.steerables[a];
					local isControlled = Utils.getNoNil(vehicle.isControlled, false);
					local controllerName = Utils.getNoNil(vehicle.controllerName, "");
					--renderText(0.5, 0.9, moSetGetGui.vsHud.fruitNameSize, "---Test---/controlled-".. tostring(isControlled).. "/controlledName".. tostring(controllerName).. "/nickname-".. tostring(g_currentMission.player.controllerName).. "/");
					if isControlled and controllerName == g_currentMission.player.controllerName then
						--renderText(0.5, 0.9, moSetGetGui.vsHud.fruitNameSize, "---Test---/controlled-".. tostring(isControlled).. "/controlledName".. tostring(controllerName).. "/nickname-".. tostring(g_playerNickname).. "/");
						break;
					else
						vehicle = nil;
					end;
				end;
			end;			
			local fillLevelInformations = {};				
			local fruitName1 = "";
			local fruitName2 = "";
			local fruitName3 = "";
			local fruitName4 = "";
			--ls17						
			if vehicle ~= nil and vehicle.getFillLevelInformation ~= nil then						
				
				vehicle:getFillLevelInformation(fillLevelInformations);				
				for k,fillLevelInformation in pairs(fillLevelInformations) do					
					if fillLevelInformation.fillType ~= nil and fillLevelInformation.fillType ~= 0 then															
						local desc = Utils.getNoNil(FruitUtil.fruitTypeToFillType[fillLevelInformation.fillType], 0);
						if desc == nil or 0 then 
							desc = Utils.getNoNil(FillUtil.fillTypeIndexToDesc[fillLevelInformation.fillType], 0);									
						end;
						if desc ~= nil and desc ~= 0 and moFillTypes ~= nil and moFillTypes[desc.index] ~= nil then
							if tonumber(k) == 1 then
								if moSetGetGui.vsHud.fruitName then	fruitName1 = moFillTypes[desc.index].fruitName;end;
								if moSetGetGui.vsHud.descName then fruitName1 = moFillTypes[desc.index].descName;end;								
							elseif tonumber(k) == 2 then								
								if moSetGetGui.vsHud.fruitName then	fruitName2 = moFillTypes[desc.index].fruitName;end;
								if moSetGetGui.vsHud.descName then fruitName2 = moFillTypes[desc.index].descName;end;
							else
								if moSetGetGui.vsHud.fruitName then
									if string.len(fruitName3) > 1 then
										fruitName3 = fruitName3.. "/".. moFillTypes[desc.index].fruitName;
									else
										fruitName3 = moFillTypes[desc.index].fruitName;
									end;
								end;
								if moSetGetGui.vsHud.descName then 
									if string.len(fruitName3) > 1 then
										fruitName3 = fruitName3.. "/".. moFillTypes[desc.index].descName;
									else
										fruitName3 = moFillTypes[desc.index].descName;
									end;
								end;
							end;
							if moSetGetGui.vsHud.fruitNamePos == 3 or 4 then
								if moSetGetGui.vsHud.fruitName then
									if string.len(fruitName4) > 1 then
										fruitName4 = fruitName4.. "/".. moFillTypes[desc.index].fruitName;
									else
										fruitName4 = moFillTypes[desc.index].fruitName;
									end;
								end;
								if moSetGetGui.vsHud.descName then 
									if string.len(fruitName4) > 1 then
										fruitName4 = fruitName4.. "/".. moFillTypes[desc.index].descName;
									else
										fruitName4 = moFillTypes[desc.index].descName;
									end;
								end;
							end;
						end;
					end;							
				end;			
			end;
			if string.len(fruitName1) > 1 or string.len(fruitName2) > 1 or string.len(fruitName3) > 1 then
				setTextBold(false);
				setTextColor(unpack(moGuiExtras.colors["yellow"]));
				local size = moSetGetGui.vsHud.fruitNameSize;
				local height = moSetGetGui.buttonGfxHeight1*(size*1000);
				local posX1 = 0;					
				local posY1 = -2;
				local posX2 = 0;					
				local posY2 = -2;
				local posX3 = 0;					
				local posY3 = -2;
				if moSetGetGui.vsHud.fruitNamePos == 1 then
					posX1 = g_currentMission.fillLevel1Bar.x;
					posY1 = g_currentMission.fillLevel1Bar.y+(g_currentMission.fillLevel1Bar.height);
					posX2 = g_currentMission.fillLevel2Bar.x;
					posY2 = g_currentMission.fillLevel2Bar.y+(g_currentMission.fillLevel2Bar.height);
					posX3 = g_currentMission.fillLevel2Bar.x;
					posY3 = g_currentMission.vehicleFillBg.y-(g_currentMission.fillLevel2Bar.height);
				elseif moSetGetGui.vsHud.fruitNamePos == 2 then
					posX1 = g_currentMission.fillLevel1Bar.x;
					posY1 = g_currentMission.fuelLevelBar.y-height;
					posX2 = g_currentMission.fillLevel1Bar.x;
					posY2 = g_currentMission.fillLevel1Bar.y-height;
					posX3 = g_currentMission.fillLevel2Bar.x;
					posY3 = g_currentMission.vehicleFillBg.y-(g_currentMission.fillLevel2Bar.height);
				elseif moSetGetGui.vsHud.fruitNamePos == 3 then
					posX1 = g_currentMission.vehicleHudBg.x;
					posY1 = g_currentMission.vehicleHudBg.y+g_currentMission.vehicleHudBg.height;
					fruitName1 = fruitName4;
				elseif moSetGetGui.vsHud.fruitNamePos == 4 then
					posX1 = g_currentMission.vehicleHudBg.x;
					posY1 = g_currentMission.vehicleHudBg.y-height;
					fruitName1 = fruitName4;
				end;				
				if string.len(fruitName1) > 1 then renderText(posX1, posY1, size, tostring(fruitName1));end;
				if string.len(fruitName2) > 1 then renderText(posX2, posY2, size, tostring(fruitName2));end;
				if string.len(fruitName3) > 1 then renderText(posX3, posY3, size, tostring(fruitName3));end;
				
			end;
			
			local desc = nil;
			if desc ~= nil and moFillTypes ~= nil and moFillTypes[desc.index] ~= nil then					
				setTextBold(false);
				setTextColor(unpack(moGuiExtras.colors["yellow"]));
				local size = moSetGetGui.vsHud.fruitNameSize;
				local posX1 = 0;					
				local posY1 = -2;
				local posX2 = 0;					
				local posY2 = -2;
				local nameLength = 0;
				local height = moSetGetGui.buttonGfxHeight1*(size*1000);
				local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
				local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;
				if moSetGetGui.vsHud.fruitNamesOn then						
					if moSetGetGui.vsHud.fruitName then	fruitName1 = moFillTypes[desc.index].fruitName;end;
					if moSetGetGui.vsHud.descName then fruitName1 = moFillTypes[desc.index].descName;end;
					if moSetGetGui.vsHud.fruitNamePos == 1 then
						--posX = moSetGetGui.lsSpeedHudX+moSetGetGui.lsSpeedHudW;
						--posY = g_currentMission.speedHud.y - (height*1.8);
						posX1 = g_currentMission.fillLevel1Bar.x;
						posY1 = g_currentMission.fillLevel1Bar.y+(g_currentMission.fillLevel1Bar.height);
						posX2 = g_currentMission.fillLevel2Bar.x;
						posY2 = g_currentMission.fillLevel2Bar.y+(g_currentMission.fillLevel2Bar.height);
					elseif moSetGetGui.vsHud.fruitNamePos == 2 then
						--setTextAlignment(2);
						--posX = g_currentMission.fillLevel1Bar.x;  --fuelLevelBar
						--posY = g_currentMission.fruitSymbolY + g_currentMission.fruitSymbolSizeY + (height/2);
					elseif moSetGetGui.vsHud.fruitNamePos == 3 then
						--setTextAlignment(2);
						--posX = g_currentMission.fruitSymbolX + (g_currentMission.fruitSymbolSizeX / 2);
						--posY = g_currentMission.speedHud.y;
					end;											
					renderText(posX1, posY1, size, tostring(fruitName1));												
					--nameFruitLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(string.len(fruitName)+moSetGetGui.screenAspectRatio);
				end;
				setTextAlignment(0);
				--ls17
				--if moSetGetGui.vsHud.fillPriceOn and fillLevel > 0 then
				--	local fillPriceStat = moSetGetGui.vsHud.fillPriceStat;
				--	if tonumber(fillPriceStat) ~= 0 then moSetGetGui.vsHud.clickArea.bestPrice = {};end;
				--	local bestPrice = 0;
				--	local animalPrice = 1;
					--if string.find(moGeneralSettings.foundAnimals, moFillTypes[desc.index].descName.. " ") then animalPrice = 1000;end;
				--	if moFillTypes[desc.index].greatDemandStationDescName ~= nil then							
				--		bestPrice = moFillTypes[desc.index].pricePerLiter/animalPrice*moFillTypes[desc.index].stationPriceMulti[moFillTypes[desc.index].greatDemandStationDescName.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
				--		moSetGetGui.vsHud.fillPriceStation = moFillTypes[desc.index].greatDemandStation;
				--	else					
				--		bestPrice = moFillTypes[desc.index].pricePerLiter/animalPrice*moFillTypes[desc.index].bestPrice*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;	
				--		moSetGetGui.vsHud.fillPriceStation = moFillTypes[desc.index].bestPriceStation;
				--	end;						
				--	bestPrice = bestPrice*fillLevel;
					--local bestPriceString = string.format("%.1f", Utils.getNoNil(bestPrice/1000,0));
				--	local bestPriceTemp = string.format("%.3f", bestPrice);
				--	local bestPriceString = g_i18n:formatMoney(bestPrice/1000);						
				--	moSetGetGui.vsHud.fillPrice = tostring(bestPriceString);
				--	local posXFruitName = posX;
				--	local posYFruitName = posY;
				--	posX = moSetGetGui.lsSpeedHudX;
				--	posY = g_currentMission.speedHud.y - (height*1.8);
				--	local priceLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(string.len(moSetGetGui.vsHud.fillPrice)+moSetGetGui.screenAspectRatio);
				--	if bestPrice > 0 then
				--		if moSetGetGui.vsHud.fillPriceIcon and moSetGetGui.vsHud.fillPriceStat == 1 then
				--			moSetGetGui["slotMoney"]:setPosition(posX, posY-(heightSettings));
				--			moSetGetGui["slotMoney"]:render();
				--			moGuiExtras:setClickAreaBestPrice(self, posX, posY-(heightSettings), widthSettings, heightSettings);
				--		elseif moSetGetGui.vsHud.fillPriceStat == 2 or moSetGetGui.vsHud.fillPriceStat == 0 then
				--			renderText(posX-0.002, posY, size, tostring(moSetGetGui.vsHud.fillPrice));
				--			if string.len(moSetGetGui.vsHud.fillPriceStation) > 1 and moSetGetGui.vsHud.fillPriceStat == 2 then moGuiExtras:setClickAreaBestPrice(self, posX-0.002, posY, priceLength, height);end;
				--		elseif moSetGetGui.vsHud.fillPriceStat == 3 and moSetGetGui.vsHud.fruitNamesOn then
				--			moGuiExtras:setClickAreaBestPrice(self, posXFruitName, posYFruitName, nameFruitLength, height);
				--		elseif moSetGetGui.vsHud.fillPriceStat == 4 then
				--			posX = g_currentMission.fruitSymbolX;
				--			posY = g_currentMission.fruitSymbolY;
				--			moGuiExtras:setClickAreaBestPrice(self, posX, posY, posX, posY);
				--		end;
				--	end;
				--else
				--	if moSetGetGui.vsHud.clickArea.bestPrice ~= nil then table.remove(moSetGetGui.vsHud.clickArea.bestPrice);end;
				--end;
				setTextColor(1, 1, 1, 1);
				setTextAlignment(0);
			end;
		else
			moSetGetGui.vsHud.fsBaseMission = false;
			if moSetGetGui.vsHud.clickArea.bestPrice ~= nil then table.remove(moSetGetGui.vsHud.clickArea.bestPrice);end;
		end;			
	end);
	moSetGetGui.vsHud.fsBaseMission = false;
end;

function moGuiExtras:setClickAreaBestPrice(self, posX, posY, horizontal, vertical)	
	if moSetGetGui.vsHud.clickArea.bestPrice == nil then return;end;
	local a = Utils.getNoNil(table.getn(moSetGetGui.vsHud.clickArea.bestPrice), 0);	
	moSetGetGui.vsHud.clickArea.bestPrice[a+1] = {posX, posX+(horizontal), posY, posY+(vertical) };
end;

function moGuiExtras:searchMapScripts(self, i3dFileName)	
	--ls17
	local ls17 = false;
	if not ls17 then return;end;
	local palSellTrigger = 0;
	local nodeRoot = Utils.loadSharedI3DFile(i3dFileName, nil, false, false);	
	local nodeId = getChildAt(nodeRoot, 0);	
	local function loopThruChildren(id)
		--print('loopThruChildren('..tostring(id)..')')
		if id == nil or id == 0 or getUserAttribute == nil then			
			return false;
		end;		
		if getUserAttribute(id, "onCreate") == "modOnCreate.FillUtilPalletSellTrigger2" then			
			local fillTypes = getUserAttribute(id, "fillTypes");
			local priceMultipliers = getUserAttribute(id, "priceMultipliers");
			if priceMultipliers ~= nil and fillTypes ~= nil then
				local x,y,z = getWorldTranslation(id);
				palSellTrigger = palSellTrigger+1;				
				if moMapObjects.palSellTrigger[palSellTrigger] == nil then moMapObjects.palSellTrigger[palSellTrigger] = {};end;
				moMapObjects.palSellTrigger[palSellTrigger].id = id;
				moMapObjects.palSellTrigger[palSellTrigger].fillTypes = {};
				moMapObjects.palSellTrigger[palSellTrigger].priceMultipliers = {};
				moMapObjects.palSellTrigger[palSellTrigger].x = tonumber(math.floor(x + .5));
				moMapObjects.palSellTrigger[palSellTrigger].y = tonumber(math.floor(y + .5));
				moMapObjects.palSellTrigger[palSellTrigger].z = tonumber(math.floor(z + .5));
				moMapObjects.palSellTrigger[palSellTrigger].foundMasterStation = false;
				local sellStationName = getUserAttribute(id, "stationName")				
				if sellStationName ~= nil then
					moMapObjects.palSellTrigger[palSellTrigger].stationName = sellStationName;
				end;			
				local splitFillTypes = Utils.splitString(" ", fillTypes);
				local splitPriceMultipliers = Utils.splitString(" ", priceMultipliers);				
				for k, v in pairs(splitFillTypes) do
					local fillType = FillUtil.fillTypeNameToInt[v];
					local descIndex = FillUtil.fillTypeIndexToDesc[v];
					if fillType ~= nil then
						moMapObjects.palSellTrigger[palSellTrigger].fillTypes[fillType] = true;
						moMapObjects.palSellTrigger[palSellTrigger].priceMultipliers[fillType] = tonumber((splitPriceMultipliers[k] or 1))
					end;
					if descIndex ~= nil and moPalFillTypes[descIndex.index] == nil then
						moPalFillTypes[descIndex.index] = {};
						moPalFillTypes[descIndex.index].fillLevel = 0;						
						moPalFillTypes[descIndex.index].pal = 0;
					end;
				end;				
			end;			
		else
			local numChildren = getNumOfChildren(id);
			--print('number of children of nodeId is '..tostring(numChildren))
			if type(numChildren) == "number" and numChildren > 0 then
				for i=1,numChildren do
					local childId = getChildAt(id, i-1);
					if childId ~= nil or childId ~= 0 then
						loopThruChildren(childId);
					end;
				end;
			end;
		end;		
		return true;
	end;
	if nodeId == 0 then
		delete(nodeRoot);		
		return false;
	end;
	loopThruChildren(nodeRoot);	
	delete(nodeRoot);
end;

function moGuiExtras:loadNewFillPlane(self, i3dFileName, fillType)
	--ls17
	local ls17 = false;
	if not ls17 then return;end;
	--for key, value in pairs(g_currentMission.moh_fillPlanes) do
	--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
	--end;
	local nodeRoot = Utils.loadSharedI3DFile(i3dFileName, nil, false, false);
	local nodeId = getChildAt(nodeRoot, 0);
	if nodeId == 0 then
		delete(nodeRoot)
		return false;
	end;
	local function loopThruChildren(id)
		--print('loopThruChildren('..tostring(id)..')'.. fillType)
		if id == nil or id == 0 then
			return false;
		end;
		if getUserAttribute(id, "fillType") == "fillPlane" then
			--print('Set FillType FillUtil.onCreateFillMaterial('..tostring(id)..')'.. tostring(fillType))
			setUserAttribute(id, "fillType", "String", tostring(fillType));
		end;
		if getUserAttribute(id, "onCreate") == "MaterialUtil.onCreateMaterial" then
			--print('FillUtil.onCreateFillMaterial('..tostring(id)..')'.. tostring(fillType))
			--setUserAttribute(id, "fillType", "String", "wheat")
			--<Attribute name="fillType" type="string" value="fillPlanes"/>
			--<Attribute name="onCreate" type="scriptCallback" value="FillUtil.onCreateFillMaterial"/>
			MaterialUtil.onCreateMaterial(true, id);
		else
			local numChildren = getNumOfChildren(id);
			--print('number of children of nodeId is '..tostring(numChildren))
			if type(numChildren) == "number" and numChildren > 0 then
				for i=1,numChildren do
					local childId = getChildAt(id, i-1);
					if childId ~= nil or childId ~= 0 then
						loopThruChildren(childId);
					end;
				end;
			end;
		end;
		return true;
	end;
	loopThruChildren(nodeId);
	delete(nodeRoot);
end;
		
function moGuiExtras:newFruitHudsLoad(self)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	if g_currentMission.individualHudFruit ~= nil and g_currentMission.individualHudFruit then
		moGeneralSettings.infoTxt = "!! New FruitHud Files already exists(IndividualHudFruits) !!";
		moSetGetGui.vsHud.newFruitHuds = false;
		return;
	end;
	if moSetGetGui.vsHud.newFruitHudsLoad or g_currentMission.mohNewFruitHudsLoad then
		moGeneralSettings.infoTxt = "!! New FruitHud Files already exists !!"
		return;
	end;
	if fileExists(MultiOverlayV2.fruitHudDir.. "*.dds") then
		for i=1,FillUtil.NUM_FILLTYPES do
			local desc = FillUtil.fillTypeIndexToDesc[i];
			if desc ~= nil and desc.name ~= nil then				
				local newHudFile = MultiOverlayV2.fruitHudDir.. desc.name.. ".dds";
				local newHudFileSmall = MultiOverlayV2.fruitHudDir.. desc.name.. "_small.dds";
				if fileExists(newHudFile) then 
					moGeneralSettings.defaultFruitOverlays[desc.index] = {};
					moGeneralSettings.defaultFruitOverlays[desc.index].hudOverlayFilename = desc.hudOverlayFilename;
					moGeneralSettings.defaultFruitOverlays[desc.index].hudOverlayFilenameSmall = desc.hudOverlayFilenameSmall;
					desc.hudOverlayFilename = newHudFile;
					moSetGetGui.vsHud.fruitHudsNormal = moSetGetGui.vsHud.fruitHudsNormal+1;
					if fileExists(newHudFileSmall) then 
						desc.hudOverlayFilenameSmall = newHudFileSmall;
						moSetGetGui.vsHud.fruitHudsSmall = moSetGetGui.vsHud.fruitHudsSmall+1;
					else
						moSetGetGui.vsHud.fruitHudsNormal = moSetGetGui.vsHud.fruitHudsNormal+1;
						desc.hudOverlayFilenameSmall = newHudFile;
					end;					
					local height = Utils.getNoNil(g_currentMission.fillTypeOverlays[i].height, 0.025000000372529);
					local width = Utils.getNoNil(g_currentMission.fillTypeOverlays[i].width, 0.015625);
					if g_currentMission.fillTypeOverlays[i] then					
						g_currentMission.fillTypeOverlays[i] = nil;
					end;
					g_currentMission:addFillTypeOverlay(i, desc.hudOverlayFilenameSmall, width, height);
				end;				
			end;
		end;
		moSetGetGui.vsHud.newFruitHudsLoad = true;
		g_currentMission.mohNewFruitHudsLoad = true;
	else
		moGeneralSettings.infoTxt = "!! Not found FruitHud Files !!"
		moSetGetGui.vsHud.newFruitHuds = false;
		moSetGetGui.vsHud.newFruitHudsLoad = false;
		g_currentMission.mohNewFruitHudsLoad = false;
	end;	
end;

function moGuiExtras:backFruitHudsLoad(self)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	if not moSetGetGui.vsHud.newFruitHudsLoad then return;end;		
	if moGeneralSettings.defaultFruitOverlays ~= nil and table.getn(moGeneralSettings.defaultFruitOverlays) > 0 then
		for i=1,FillUtil.NUM_FILLTYPES do
			local desc = FillUtil.fillTypeIndexToDesc[i];
			if desc ~= nil and desc.name ~= nil and moGeneralSettings.defaultFruitOverlays[desc.index] ~= nil then				
				desc.hudOverlayFilename = moGeneralSettings.defaultFruitOverlays[desc.index].hudOverlayFilename;
				desc.hudOverlayFilenameSmall = moGeneralSettings.defaultFruitOverlays[desc.index].hudOverlayFilenameSmall;				
				local height = Utils.getNoNil(g_currentMission.fillTypeOverlays[i].height, 0.025000000372529);
				local width = Utils.getNoNil(g_currentMission.fillTypeOverlays[i].width, 0.015625);				
				if g_currentMission.fillTypeOverlays[i] then					
					g_currentMission.fillTypeOverlays[i] = nil;
				end;
				g_currentMission:addFillTypeOverlay(i, desc.hudOverlayFilenameSmall, width, height);				
			end;
		end;
		moGeneralSettings.defaultFruitOverlays = {};
		moSetGetGui.vsHud.newFruitHudsLoad = false;
		moSetGetGui.vsHud.newFruitHuds = false;
		g_currentMission.mohNewFruitHudsLoad = false;
		moSetGetGui.vsHud.fruitHudsNormal = 0;
		moSetGetGui.vsHud.fruitHudsSmall = 0;
	end;	
end;

function moGuiExtras:updateFillUtilPalletOld(self)
	--ls17
	local ls17 = false;
	if not ls17 then return;end;
	if moFillUtilPallet ~= nil then table.remove(moFillUtilPallet);end;
	moFillUtilPallet = {};
	for k1, v1 in pairs(g_currentMission.nodeObjects) do		
		local object = g_currentMission:getNodeObject(k1);
		if object ~= nil then
			if object:isa(FillUtilPallet) then
				--print(tostring(MultiOverlayV2:tableToString(object)));
				--for key, value in pairs(object) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--end;
				if object.nodeId ~= nil and object.nodeId ~= 0 and moFillUtilPallet[object.nodeId] == nil then 
					local x, y, z = getWorldTranslation(object.nodeId);
					if x ~= nil and y ~= nil and z ~= nil then
						moFillUtilPallet[object.nodeId] = {};
						moFillUtilPallet[object.nodeId].nodeId = object.nodeId;
						moFillUtilPallet[object.nodeId].x = tonumber(math.floor(x + .5));
						moFillUtilPallet[object.nodeId].y = tonumber(math.floor(y + .5));
						moFillUtilPallet[object.nodeId].z = tonumber(math.floor(z + .5));
						moFillUtilPallet[object.nodeId].fillLevel = Utils.getNoNil(object.fillLevel, 0);
					end;					
				end;
			end;
			--object:delete();
		end;
	end;	
end;

function moGuiExtras:updateFillUtilPallet(self, itemClass)
	--ls17
	local ls17 = false;
	if not ls17 then return;end;
	if moFillUtilPallet ~= nil then table.remove(moFillUtilPallet);end;
	moFillUtilPallet = {};
	if MultiOverlayV2.event.itemToSave_s and moFillUtilItemToServer ~= nil then
		for a, mapFillUtilPal in pairs(moFillUtilItemToServer) do
		--for a=1, #moFillUtilItemToServer do
			if moFillUtilItemToServer[a] ~= nil then
				local nodeId = Utils.getNoNil(moFillUtilItemToServer[a].nodeId, 0);
				if moFillUtilItemToServer[a].className == itemClass then
					if nodeId ~= nil and nodeId ~= 0 and moFillUtilPallet[nodeId] == nil then
						moFillUtilPallet[nodeId] = {};
						moFillUtilPallet[nodeId].nodeId = nodeId;
						moFillUtilPallet[nodeId].x = moFillUtilItemToServer[a].x;
						moFillUtilPallet[nodeId].y = moFillUtilItemToServer[a].y;
						moFillUtilPallet[nodeId].z = moFillUtilItemToServer[a].z;
						moFillUtilPallet[nodeId].fillLevel = Utils.getNoNil(moFillUtilItemToServer[a].fillLevel, 0);
					end;
				end;
			end;
		end;
	else
		for k1, v1 in pairs(g_currentMission.nodeObjects) do		
			local object = g_currentMission:getNodeObject(k1);
			if object ~= nil then
				if object:isa(FillUtilPallet) then					
					if object.nodeId ~= nil and object.nodeId ~= 0 and moFillUtilPallet[object.nodeId] == nil then 
						local x, y, z = getWorldTranslation(object.nodeId);
						if x ~= nil and y ~= nil and z ~= nil then
							moFillUtilPallet[object.nodeId] = {};
							moFillUtilPallet[object.nodeId].nodeId = object.nodeId;
							moFillUtilPallet[object.nodeId].x = tonumber(math.floor(x + .5));
							moFillUtilPallet[object.nodeId].y = tonumber(math.floor(y + .5));
							moFillUtilPallet[object.nodeId].z = tonumber(math.floor(z + .5));
							moFillUtilPallet[object.nodeId].fillLevel = Utils.getNoNil(object.fillLevel, 0);
						end;					
					end;
				end;
			end;
		end;
	end;	
end;

function moGuiExtras:disableExtraDraws(self, closeSmall, closeExtraDraw, closePreviewWeather, closePreviewMoneyChangeLast)
	--ls17
	--local ls17 = false;
	--if not ls17 then return;end;
	if closeExtraDraw then
		moGuiMiniPdaSlots.fieldsInfo.isExtraDraw = false;
		moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd = 300;
		moGuiMiniPdaSlots.fieldsInfo.extraDrawField = 0;
	end;
	if closeSmall then
		moGuiMiniPdaSlots.isSeeSmallDraw = false;
		moGuiMiniPdaSlots.isSeeSmallDrawEnd = 350;
	end;
	if closePreviewWeather then
		moSetGetGui.wtmHud.isSeePreviewWeather = false;
		moSetGetGui.wtmHud.seePreviewWeatherEnd = 350;
	end;
	if closePreviewMoneyChangeLast then
		moSetGetGui.wtmHud.isSeePreviewMoneyChangeLast = false;
		moSetGetGui.wtmHud.seePreviewMoneyChangeLastEnd = 250;
	end;
	moSetGetGui.page[1].oldPrice = false;
	moSetGetGui.page[1].pageTimer = 300;
	moSetGetGui.page[1].oldPriceString = "";
	moSetGetGui:resetOverlayDesignGroundAndLine(self);
end;

function moGuiExtras:liveTicker(self, on, off, first)
	--ls17
	local ls17 = false;
	if not ls17 then return false;end;
	if on ~= nil and on then
		if moGeneralSettings.modTables.liveTickerCurrentMission ~= nil then
			g_currentMission.LiveTicker = moGeneralSettings.modTables.liveTickerCurrentMission;					
		end;
		return true;
	end;
	if off ~= nil and off then		
		if g_currentMission.LiveTicker ~= nil then
			if moGeneralSettings.modTables.liveTicker.table ~= nil and moGeneralSettings.modTables.liveTicker.modName ~= nil then
				local env = getfenv(0);
				local modName = moGeneralSettings.modTables.liveTicker.modName;
				if not first then 
					if env[modName] ~= nil and env[modName]["LiveTicker"] ~= nil then
						if #env[modName].LiveTicker.MSG > 0 then
							moGeneralSettings.infoTxt = "LiveTicker active !!(wait)";
							moGeneralSettings.liveTicker = true;
							return false;
						else
							moGeneralSettings.infoTxt = "";
							for k,v in pairs(env[modName].LiveTicker.MSG) do							
								table.remove(env[modName].LiveTicker.MSG,k);							
							end;
							if #env[modName].LiveTicker.lastMSG > 0 then
								for k,v in pairs(env[modName].LiveTicker.lastMSG) do							
									table.remove(env[modName].LiveTicker.lastMSG,k);							
								end;
							end;
							g_currentMission.LiveTicker = nil;
							return true;
						end;
					end;										
				else					
					if env[modName] ~= nil and env[modName]["LiveTicker"] ~= nil then
						if #env[modName].LiveTicker.MSG > 0 then
							for k,v in pairs(env[modName].LiveTicker.MSG) do							
								table.remove(env[modName].LiveTicker.MSG,k);							
							end;
						end;
						if #env[modName].LiveTicker.lastMSG > 0 then
							for k,v in pairs(env[modName].LiveTicker.lastMSG) do							
								table.remove(env[modName].LiveTicker.lastMSG,k);							
							end;
						end;
					end;
					g_currentMission.LiveTicker = nil;
					return true;
				end;				
			end;		
		end;
		return true;
	end;
	return false;
end;

function moGuiExtras:searchMods(self)	
	--ls17
	if g_seasons ~= nil and g_seasons.forecast ~= nil then
		g_seasons.forecast.vanillaNotificationOffset = 0;
		moSetGetGui.wtmHud.seasonsMod.dayHeight = g_seasons.forecast.hud.dayHeight;
		moSetGetGui.wtmHud.seasonsMod.dayWidth = g_seasons.forecast.hud.dayWidth;
		moSetGetGui.wtmHud.seasonsMod.iconWidthSmall = g_seasons.forecast.hud.iconWidthSmall;
		moSetGetGui.wtmHud.seasonsMod.iconHeightSmall = g_seasons.forecast.hud.iconHeightSmall;
	end;
	local ls17 = true;
	if not ls17 then return;end;
	local liveTicker = true;
	local mietMod = true;
	local seasonsMod = false;
	local env = getfenv(0);	
	for modName,isLoaded in pairs(g_modIsLoaded) do
		--print("modname.....".. tostring(modName))
		if isLoaded then			
			if not seasonsMod and env[modName] ~= nil and env[modName]["FS17_RM_Seasons"] ~= nil then
				seasonsMod = true;
				moGeneralSettings.seasonsMod = true; --g_seasons.forecast
				--moGeneralSettings.modTables.seasonsMod = {};
				--if MultiOverlayV2.isMp and not MultiOverlayV2.loadHostServer then
				--	moGeneralSettings.modTables.seasonsMod.table = env[modName];
				--else
				--	moGeneralSettings.modTables.seasonsMod.table = env[modName].FS17_RM_Seasons;
				--end;
				--g_currentMission.timeTextSize = g_currentMission.timeTextSize-0.003				
				if g_seasons ~= nil and g_seasons.forecast ~= nil then
					g_seasons.forecast.vanillaNotificationOffset = 0;									
				end;				
				seasonsMod = true;
				break;
			end;
			if not liveTicker and env[modName] ~= nil and env[modName]["LiveTicker"] ~= nil then
				--print("found live ticker.............")	
				moGeneralSettings.modTables.liveTicker = {};
				moGeneralSettings.modTables.liveTicker.table = env[modName].LiveTicker;
				moGeneralSettings.modTables.liveTicker.modName = modName;
				moGeneralSettings.modTables.liveTickerCurrentMission = g_currentMission.LiveTicker;				
				liveTicker = true;									
			end							
			if not mietMod and env[modName] ~= nil and env[modName]["Miet_Mod_LS15"] ~= nil then			
				--print("found Miet_Mod_LS15 .............")	
				moGeneralSettings.modTables.mietMod = {};
				moGeneralSettings.modTables.mietMod.modName = modName;
				moGeneralSettings.modTables.mietMod.table = env[modName].Miet_Mod_LS15;
				--print(tostring(MultiOverlayV2:tableToString(moGeneralSettings.modTables.mietMod.table)));
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--end;
				--print("found Miet_Mod_LS15 Vehicles.............")
				--moGeneralSettings.modTables.mietMod.table.g_MietModVehicles.visible = false;
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table.g_MietModVehicles) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--	if tostring(key) == "tableTextInfos" then
				--		print("found Miet_Mod_LS15 textInfos 0.............")						
				--		for key1, value1 in pairs(value[0]) do
				--			print("key1 und value1 ...".. tostring(key1).. "-----".. tostring(value1))
				--			if tostring(key1) == "fixedWidth" then
				--				moGeneralSettings.modTables.mietMod.table.g_MietModVehicles.tableTextInfos[0].fixedWidth = true;
				--				moGeneralSettings.modTables.mietMod.table.g_MietModVehicles.tableTextInfos[0].textSize = 0.015;
				--			end;
				--		end;
				--		print("found Miet_Mod_LS15 textInfos 1.............")						
				--		for key1, value1 in pairs(value[1]) do
				--			print("key1 und value1 ...".. tostring(key1).. "-----".. tostring(value1))
				--			if tostring(key1) == "fixedWidth" then
				--				moGeneralSettings.modTables.mietMod.table.g_MietModVehicles.tableTextInfos[1].fixedWidth = true;
				--				moGeneralSettings.modTables.mietMod.table.g_MietModVehicles.tableTextInfos[1].textSize = 0.015;
				--			end;
				--		end;
				--		print("found Miet_Mod_LS15 textInfos 2.............")						
				--		for key1, value1 in pairs(value[2]) do
				--			print("key1 und value1 ...".. tostring(key1).. "-----".. tostring(value1))
				--			if tostring(key1) == "fixedWidth" then
				--				moGeneralSettings.modTables.mietMod.table.g_MietModVehicles.tableTextInfos[2].fixedWidth = true;
				--				moGeneralSettings.modTables.mietMod.table.g_MietModVehicles.tableTextInfos[2].textSize = 0.015;
				--			end;
				--		end;
				--	end;
				--end;				
				--print("found Miet_Mod_LS15 GUI3.............")				
				--print(tostring(MultiOverlayV2:tableToString(moGeneralSettings.mietModLS15Table.g_GUI2)));
				--print("found Miet_Mod_LS15 table.............")
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table.GUI3) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--end;
				--print("found Miet_Mod_LS15 GUI4.............")
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table.g_GUI4) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--end;
				--print("found Miet_Mod_LS15 GUI5.............")
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table.g_GUI5) do
					--print("key und value ...".. tostring(key).. "-----".. tostring(value))
					--if tostring(key) == "position" then
					--	print("found Miet_Mod_LS15 GUI5 position.............")
					--	print(tostring(MultiOverlayV2:tableToString(value)))
					--end;
					--if tostring(key) == "absPosition" then
					--	print("found Miet_Mod_LS15 GUI5 absPosition.............")
					--	print(tostring(MultiOverlayV2:tableToString(value)))
					--end;					
					--if tostring(key) == "size" then
					--	print("found Miet_Mod_LS15 GUI5 size.............")
					--	print(tostring(MultiOverlayV2:tableToString(value)))
					--end;
				--end;
				--print("found Miet_Mod_LS15 GUI6.............")				
				--print(tostring(MultiOverlayV2:tableToString(moGeneralSettings.mietModLS15Table.g_GUI2)));
				--print("found Miet_Mod_LS15 table.............")
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table.g_GUI6) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--end;
				--print("found Miet_Mod_LS15 GUI _G.............")				
				--print(tostring(MultiOverlayV2:tableToString(moGeneralSettings.mietModLS15Table.g_GUI2)));
				--print("found Miet_Mod_LS15 table.............")
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table._G) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--end;
				--print("found Miet_Mod_LS15 GUI7.............")				
				--print(tostring(MultiOverlayV2:tableToString(moGeneralSettings.mietModLS15Table.g_GUI2)));
				--print("found Miet_Mod_LS15 table.............")
				--for key, value in pairs(moGeneralSettings.modTables.mietMod.table.g_GUI7) do
				--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
				--end;
				
				mietMod = true;
			end;
		end;
	end;					
end;

function moGuiExtras:helpHudDraws(self, load, copyDefault, artDesign)
	--ls17
	local ls17 = false;
	if not ls17 then return;end;
	if copyDefault then
		moSetGetGui.helpHud.default = {};
		moSetGetGui.helpHud.default.textSize = g_currentMission.hudHelpTextSize;
		moSetGetGui.helpHud.default.topTextSize = g_currentMission.hudHelpTopTextSize;
		moSetGetGui.helpHud.default.textColor = g_currentMission.hudHelpTextColor;		
		moSetGetGui.helpHud.default.textPosX1 = g_currentMission.hudHelpTextPosX1;
		moSetGetGui.helpHud.default.textPosX2 = g_currentMission.hudHelpTextPosX2;
		moSetGetGui.helpHud.default.textLineSpacing = g_currentMission.hudHelpTextLineSpacing;
		moSetGetGui.helpHud.default.width = g_currentMission.hudHelpContentWidth;
		moSetGetGui.helpHud.default.height = g_currentMission.hudHelpContentHeight;
		moSetGetGui.helpHud.default.contentOverlay = g_currentMission.hudHelpContentOverlay;
		moSetGetGui.helpHud.default.topOverlay = g_currentMission.hudHelpTopOverlay;
		moSetGetGui.helpHud.default.topTextColor = g_currentMission.hudHelpTopTextColor;
		moSetGetGui.helpHud.default.seperatorOverlay = g_currentMission.hudHelpSeperatorOverlay;
		moSetGetGui.helpHud.default.posX = g_currentMission.hudHelpPosX;
		moSetGetGui.helpHud.default.posY = g_currentMission.hudHelpPosY;
		moSetGetGui.helpHud.default.warningBaseOverlay = g_currentMission.hudWarningBaseOverlay;
		--moSetGetGui.helpHud.default.warningIconOverlay = g_currentMission.hudWarningIconOverlay;
		moSetGetGui.helpHud.default.warningIconBgOverlay = g_currentMission.hudWarningIconBgOverlay;
	end;
	if artDesign ~= nil and artDesign then		
		if moSetGetGui.helpHud.artDesign then
			g_currentMission.hudHelpContentOverlay = moSetGetGui["helpHudGround"];
			g_currentMission.hudHelpContentOverlay.x = moSetGetGui.helpHud.default.contentOverlay.x;
			g_currentMission.hudHelpContentOverlay.y = moSetGetGui.helpHud.default.contentOverlay.y;
			g_currentMission.hudHelpContentOverlay:setDimension(moSetGetGui.helpHud.width, moSetGetGui.helpHud.height);
			g_currentMission.hudWarningBaseOverlay = moSetGetGui["helpHudWarningGround"];
			g_currentMission.hudWarningBaseOverlay.x = moSetGetGui.helpHud.default.warningBaseOverlay.x;
			g_currentMission.hudWarningBaseOverlay.y = moSetGetGui.helpHud.default.warningBaseOverlay.y;
			g_currentMission.hudWarningBaseOverlay.width = moSetGetGui.helpHud.default.warningBaseOverlay.width;
			g_currentMission.hudWarningBaseOverlay.height = moSetGetGui.helpHud.default.warningBaseOverlay.height;
			g_currentMission.hudWarningIconOverlay.visible = false;
			g_currentMission.hudWarningIconBgOverlay = moSetGetGui["helpHudWarning"];
			g_currentMission.hudWarningIconBgOverlay.x = moSetGetGui.helpHud.default.warningIconBgOverlay.x;
			g_currentMission.hudWarningIconBgOverlay.y = moSetGetGui.helpHud.default.warningIconBgOverlay.y;
			g_currentMission.hudWarningIconBgOverlay.width = moSetGetGui.helpHud.default.warningIconBgOverlay.width/2;
			g_currentMission.hudWarningIconBgOverlay.height = moSetGetGui.helpHud.default.warningIconBgOverlay.height/2;
			--g_currentMission.hudHelpContentOverlay.width = moSetGetGui.helpHud.contentOverlay.width;
			--g_currentMission.hudHelpContentOverlay.height = moSetGetGui.helpHud.contentOverlay.height+0.003;
			if moSetGetGui.helpHud.design == 1 then
				g_currentMission.hudHelpTopOverlay = moSetGetGui["helpTopHudGround"];
				--g_currentMission.hudHelpTopOverlay.visible = false;
				--moSetGetGui.helpHud.height = moSetGetGui.helpHud.height+moSetGetGui.helpHud.default.topOverlay.height
				--g_currentMission.hudHelpContentHeight = moSetGetGui.helpHud.height;
				--g_currentMission.hudHelpContentOverlay.y = moSetGetGui.helpHud.default.topOverlay.y;
				--g_currentMission.hudHelpContentOverlay:setDimension(moSetGetGui.helpHud.width, moSetGetGui.helpHud.height);
				g_currentMission.hudHelpTopOverlay.x = moSetGetGui.helpHud.default.topOverlay.x;
				g_currentMission.hudHelpTopOverlay.y = moSetGetGui.helpHud.default.topOverlay.y;
				--g_currentMission.hudHelpTopOverlay.width = moSetGetGui.helpHud.default.topOverlay.width;
				--g_currentMission.hudHelpTopOverlay.height = moSetGetGui.helpHud.default.topOverlay.height;
				g_currentMission.hudHelpTopOverlay:setDimension(moSetGetGui.helpHud.width, moSetGetGui.helpHud.height);
				--g_currentMission.hudHelpTopOverlay:setColor(unpack(moGuiMiniPdaSlots.inactiveColor));
			else
				--g_currentMission.hudHelpTopOverlay.visible = true;
				g_currentMission.hudHelpTopOverlay = moSetGetGui.helpHud.topOverlay;
			end;
			--g_currentMission.hudHelpSeperatorOverlay = moSetGetGui["helpHudLine"];
			--g_currentMission.hudHelpSeperatorOverlay.x = moSetGetGui.helpHud.default.seperatorOverlay.x;
			--g_currentMission.hudHelpSeperatorOverlay.y = moSetGetGui.helpHud.default.seperatorOverlay.y;
			--g_currentMission.hudHelpSeperatorOverlay:setDimension(moSetGetGui.helpHud.seperatorOverlay.width, moSetGetGui.helpHud.seperatorOverlay.height);
			--g_currentMission.hudHelpSeperatorOverlay.width = moSetGetGui.helpHud.seperatorOverlay.width;
			--g_currentMission.hudHelpSeperatorOverlay.height = moSetGetGui.helpHud.seperatorOverlay.height;
			moSetGetGui.helpHud.textColor = moGuiMiniPdaSlots.activeColor;
			moSetGetGui.helpHud.topTextColor = moGuiMiniPdaSlots.inactiveColor;
		else
			--g_currentMission.hudHelpTopOverlay.visible = true;
			g_currentMission.hudHelpContentOverlay = moSetGetGui.helpHud.default.contentOverlay;
			g_currentMission.hudHelpTopOverlay = moSetGetGui.helpHud.default.topOverlay;
			g_currentMission.hudHelpSeperatorOverlay = moSetGetGui.helpHud.default.seperatorOverlay;
			g_currentMission.hudWarningBaseOverlay = moSetGetGui.helpHud.default.warningBaseOverlay;
			g_currentMission.hudWarningIconBgOverlay = moSetGetGui.helpHud.default.warningIconBgOverlay;
			g_currentMission.hudWarningIconOverlay.visible = false;
			g_currentMission.hudHelpContentOverlay:setDimension(moSetGetGui.helpHud.default.width, moSetGetGui.helpHud.default.height);
			g_currentMission.hudHelpTopOverlay:setDimension(moSetGetGui.helpHud.default.width, moSetGetGui.helpHud.default.height);
			g_currentMission.hudHelpSeperatorOverlay:setDimension(moSetGetGui.helpHud.default.width - 0.015, nil);
			g_currentMission.hudHelpPosX = moSetGetGui.helpHud.default.posX;
			if moSetGetGui.helpHud.designColor then
				moSetGetGui.helpHud.textColor = moGuiExtras.colors[moSetGetGui.helpHud.textColors[moSetGetGui.helpHud.designTextColor]];
				moSetGetGui.helpHud.topTextColor = moGuiExtras.colors[moSetGetGui.helpHud.textColors[moSetGetGui.helpHud.designTextColor]];
			else
				g_currentMission.hudHelpTextColor = moSetGetGui.helpHud.default.textColor;
				g_currentMission.hudHelpTopTextColor = moSetGetGui.helpHud.default.topTextColor;
			end;
		end;
	end;
	if load ~= nil then		
		if load then
			--g_currentMission.hudHelpContentOverlay = moSetGetGui.helpHud.contentOverlay;
			--g_currentMission.hudHelpTopOverlay = moSetGetGui.helpHud.topOverlay;			
			--g_currentMission.hudHelpSeperatorOverlay = moSetGetGui.helpHud.seperatorOverlay;
			
			g_currentMission.hudHelpTextSize = moSetGetGui.helpHud.textSize;
			g_currentMission.hudHelpTopTextSize = moSetGetGui.helpHud.topTextSize;
			g_currentMission.hudHelpTextColor = moSetGetGui.helpHud.textColor;
			g_currentMission.hudHelpTopTextColor = moSetGetGui.helpHud.topTextColor;
			g_currentMission.hudHelpTextPosX1 = moSetGetGui.helpHud.textPosX1;
			g_currentMission.hudHelpTextPosX2 = moSetGetGui.helpHud.textPosX2;
			g_currentMission.hudHelpTextLineSpacing = moSetGetGui.helpHud.textLineSpacing;
			g_currentMission.hudHelpTextContentWidth = moSetGetGui.helpHud.width;
			g_currentMission.hudHelpTextContentHeight = moSetGetGui.helpHud.height;
		else
			g_currentMission.hudWarningBaseOverlay = moSetGetGui.helpHud.default.warningBaseOverlay;
			g_currentMission.hudWarningIconOverlay.visible = true;
			g_currentMission.hudWarningIconBgOverlay = moSetGetGui.helpHud.default.warningIconBgOverlay;
			g_currentMission.hudHelpContentOverlay = moSetGetGui.helpHud.default.contentOverlay;
			g_currentMission.hudHelpContentOverlay.width = moSetGetGui.helpHud.default.width;
			g_currentMission.hudHelpContentWidth = moSetGetGui.helpHud.default.width;
			g_currentMission.hudHelpContentHeight = moSetGetGui.helpHud.default.height;
			g_currentMission.hudHelpTextSize = moSetGetGui.helpHud.default.textSize;
			g_currentMission.hudHelpTopTextSize = moSetGetGui.helpHud.default.topTextSize;
			g_currentMission.hudHelpTextColor = moSetGetGui.helpHud.default.textColor;
			g_currentMission.hudHelpTopTextColor = moSetGetGui.helpHud.default.topTextColor;
			g_currentMission.hudHelpTextPosX1 = moSetGetGui.helpHud.default.textPosX1;
			g_currentMission.hudHelpTextPosX2 = moSetGetGui.helpHud.default.textPosX2;
			g_currentMission.hudHelpTextLineSpacing = moSetGetGui.helpHud.default.textLineSpacing;
			g_currentMission.hudHelpTextContentWidth = moSetGetGui.helpHud.default.width;
			g_currentMission.hudHelpTextContentHeight = moSetGetGui.helpHud.default.height;
			g_currentMission.hudHelpTopOverlay = moSetGetGui.helpHud.default.topOverlay;
			--g_currentMission.hudHelpTopOverlay.width = moSetGetGui.helpHud.default.width;
			g_currentMission.hudHelpSeperatorOverlay = moSetGetGui.helpHud.default.seperatorOverlay;
			--g_currentMission.hudHelpSeperatorOverlay.width = moSetGetGui.helpHud.default.seperatorOverlay.width + 0.01 ;
			g_currentMission.hudHelpContentOverlay:setDimension(moSetGetGui.helpHud.default.width, moSetGetGui.helpHud.default.height);
			g_currentMission.hudHelpTopOverlay:setDimension(moSetGetGui.helpHud.default.width, moSetGetGui.helpHud.default.height);
			g_currentMission.hudHelpSeperatorOverlay:setDimension(moSetGetGui.helpHud.default.width - 0.015, nil);
			g_currentMission.hudHelpPosX = moSetGetGui.helpHud.default.posX;
			g_currentMission.hudHelpPosY = moSetGetGui.helpHud.default.posY;
		end;
	end;
end;

function moGuiExtras:loadSaveWeather(self, load, isServer)
	--ls17
	local ls17 = false;
	if not ls17 then return;end;
	if not load then
		MultiOverlayV2.event.weatherDays_s = {};
		MultiOverlayV2.event.weatherDaysString_s = "";
		for a=1, 14 do				
			MultiOverlayV2.event.weatherDays_s[a] = {};
			local day = g_currentMission.environment.currentDay + a - 1;
			--ls17
			local weatherType = g_currentMission.environment:getRainTypeIdAtDay(day) or "sun";
			MultiOverlayV2.event.weatherDays_s[a].tempDay = g_currentMission.environment.weatherTemperaturesDay[a]; --weatherTemperaturesNight
			MultiOverlayV2.event.weatherDays_s[a].tempNight = g_currentMission.environment.weatherTemperaturesNight[a];
			MultiOverlayV2.event.weatherDays_s[a].weatherType = weatherType;
			MultiOverlayV2.event.weatherDaysString_s = MultiOverlayV2.event.weatherDaysString_s.. "Day:".. tostring(MultiOverlayV2.event.weatherDays_s[a].tempDay).. " ".. tostring(MultiOverlayV2.event.weatherDays_s[a].tempNight).. " ".. tostring(MultiOverlayV2.event.weatherDays_s[a].weatherType).. " ";
		end;
		MultiOverlayV2.event.loadWeather_s = true;	
	end;
	if load and MultiOverlayV2.event.loadWeather_s then
		for a=1, 14 do
			local day = g_currentMission.environment.currentDay + a - 1;			
			--ls17
			g_currentMission.environment.weatherTemperaturesDay[a] = MultiOverlayV2.event.weatherDays_s[a].tempDay;
			g_currentMission.environment.weatherTemperaturesNight[a] = MultiOverlayV2.event.weatherDays_s[a].tempNight;			
		end;		
	end;
end;

function moGuiExtras:infoEditState(self, editMaster, editUser)
	local unlockMaster = false;
	local unlockUser = false;
	if editMaster == nil and editUser == nil then
		return moSetGetGui.showGui.infoEditMasterPwUnLock, moSetGetGui.showGui.infoEditPwUnLock;
	end;
	if editMaster == 2 and moSetGetGui.showGui.infoEditMasterPwUnLock then
		unlockMaster = true;
	end;
	if editMaster == 2 and editStateUser == 2 and moSetGetGui.showGui.infoEditMasterPwUnLock and moSetGetGui.showGui.infoEditPwUnLock or MultiOverlayV2.event.infoEditUser_s == 1 then 
		unlockMaster = true;
		unlockUser = true;
		return true, true;
	end;
	if editUser == 2 and moSetGetGui.showGui.infoEditPwUnLock then
		unlockUser = true;
	end;		
	if MultiOverlayV2.event.infoEditUser_s == 2 and moSetGetGui.showGui.infoEditPwUnLock then
		unlockUser = true;
	end;
	if MultiOverlayV2.event.infoEditUser_s == 3 and moSetGetGui.showGui.infoEditMasterPwUnLock then
		unlockMaster = true;
	end;
	return unlockMaster, unlockUser;
end;

function moGuiExtras:getAllowedCharacters()
	local allowedSpan = { from = 32, to = 591 };
	local prohibitedUnicodes = { [34] = true, [39] = true, [94] = true, [96] = true, [215] = true, [247] = true };
	for unicode=127,190 do
		prohibitedUnicodes[unicode] = true;
	end;
	local result = {};
	for unicode=allowedSpan.from,allowedSpan.to do
		prohibitedUnicodes[unicode] = prohibitedUnicodes[unicode] or false;
		result[unicode] = not prohibitedUnicodes[unicode] and getCanRenderUnicode(unicode);
		--if getCanRenderUnicode(unicode) then
			--print(string.format('allowedCharacters[%d]=%s (%q) (prohibited=%s, getCanRenderUnicode()=true)', unicode, tostring(result[unicode]), unicodeToUtf8(unicode), tostring(prohibitedUnicodes[unicode])));
			--print("-unicode:".. unicode, "-result:".. tostring(result[unicode]), "-unicodeToUtf8:".. unicodeToUtf8(unicode), "-prohibited..:".. tostring(prohibitedUnicodes[unicode]));
		--end;
	end;
	return result;
end;

function moGuiExtras:setNewLanguageText(self, regName, newName, onlyRemove)
	local file = MultiOverlayV2.settingsDir.. "language".. MultiOverlayV2.language.. ".xml";		
	local saveFile = MultiOverlayV2.saveGameDir.. "language".. MultiOverlayV2.language.. ".xml";
	if fileExists(saveFile) then file = saveFile;end;	
	local generateNew = false;
	if moLanguage[regName] ~= nil then 
		table.remove(moLanguage[regName]);
		generateNew = true;
	else
		if not onlyRemove then moLanguage[regName] = {newName};generateNew = true;end;
	end;
	if generateNew then
		local a = 0;
		local Xml = createXMLFile("MultiOverlayV2_XML", file, "language");
		for name, v in pairs(moLanguage) do
			if name ~= nil and moLanguage[name] ~= nil and moLanguage[name][1] ~= nil then
				local xmlNameTag = ("language.text(%d)"):format(a);
				--setXMLInt(Xml, xmlNameTag.."#id", a);
				setXMLString(Xml, xmlNameTag.."#name", name);
				setXMLString(Xml, xmlNameTag.."#text", moLanguage[name][1]);			
				a = a+1;
			end;
		end;
		saveXMLFile(Xml);
	end;
end;

function moGuiExtras:setStationTriggerNew(self, delete, tipTrigger, fruitDescName, stationName, xmlString, stationsUpdate, multiplier)
	if tipTrigger == nil then return;end;
	function deleteFruits(tipTrigger, fruitName)
		local desc = FillUtil.fillTypeNameToDesc[fruitName];		
		if desc == nil then return;end;
		if tipTrigger.acceptedFillTypes[desc.index] == nil then
			moGeneralSettings.replaceStationsTrigger[stationName].deleteFruits[fruitName] = nil;
			return;
		end;
		tipTrigger.acceptedFillTypes[desc.index] = nil;
		tipTrigger.priceMultipliers[desc.index] = nil;
	end;
	if xmlString == nil and not delete then
		local desc = FillUtil.fillTypeNameToDesc[fruitDescName];		
		if desc == nil then return;end;	
		local defaultValues = 0.25;
		if multiplier ~= nil then defaultValues = tonumber(multiplier);end;
		if tipTrigger.priceMultipliers == nil then tipTrigger.priceMultipliers = {};end;
		if tipTrigger.acceptedFillTypes == nil then tipTrigger.acceptedFillTypes = {};end;
		if tipTrigger.priceMultipliers ~= nil and tipTrigger.acceptedFillTypes ~= nil then			
			tipTrigger.acceptedFillTypes[desc.index] = true;			
			tipTrigger.priceMultipliers[desc.index] = tonumber(defaultValues);			
			local pricePerLiter = FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter;
			local setPrice = false;
			if tonumber(pricePerLiter) == 0 or pricePerLiter == nil then								
				FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter = tonumber(defaultValues);
				setPrice = true;
			end;							
			local previousHourPrice = FillUtil.fillTypeIndexToDesc[desc.index].previousHourPrice;
			if tonumber(previousHourPrice) == 0 or previousHourPrice == nil then								
				FillUtil.fillTypeIndexToDesc[desc.index].previousHourPrice = tonumber(defaultValues);
			end;
			local startPricePerLiter = FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter;
			if tonumber(startPricePerLiter) == 0 or startPricePerLiter == nil then								
				FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter = tonumber(defaultValues);
			end;
			if moGeneralSettings.replaceStationsTrigger[stationName] == nil then moGeneralSettings.replaceStationsTrigger[stationName] = {};moGeneralSettings.replaceStationsTrigger[stationName].name = tostring(stationName);moGeneralSettings.replaceStationsTrigger[stationName].deleteFruits = {};moGeneralSettings.replaceStationsTrigger[stationName].setFruits = {};end;			
			moGeneralSettings.replaceStationsTrigger[stationName].setFruits[fruitDescName] = {fruitName=tostring(fruitDescName), multiplier=tostring(tipTrigger.priceMultipliers[desc.index]), pricePerLiter=nil};
			if setPrice then
				moGeneralSettings.replaceStationsTrigger[stationName].setFruits[fruitDescName].pricePerLiter = tostring(FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter);
			end;
			if moGeneralSettings.replaceStationsTrigger[stationName].deleteFruits[fruitDescName] ~= nil then
				moGeneralSettings.replaceStationsTrigger[stationName].deleteFruits[fruitDescName] = nil;
			end;
		end;
		if stationsUpdate then moSetGetStationes:setStationUpdate(self, true, nil);end;	
	elseif xmlString ~= nil and not delete then
		local setFruitsSplit = Utils.splitString(":", xmlString);
		local fruitName = setFruitsSplit[1];
		local multiplier = setFruitsSplit[2];
		local pricePerLiter = setFruitsSplit[3];
		if fruitName == nil or multiplier == nil then return;end;
		local desc = FillUtil.fillTypeNameToDesc[fruitName];
		if desc == nil then return;end;
		if tipTrigger.priceMultipliers[desc.index] ~= nil and tipTrigger.priceMultipliers[desc.index] == tonumber(multiplier) then
			moGeneralSettings.replaceStationsTrigger[stationName].setFruits[fruitName] = nil;
			return;
		end;
		tipTrigger.acceptedFillTypes[desc.index] = true;
		tipTrigger.priceMultipliers[desc.index] = tonumber(multiplier);
		if pricePerLiter ~= nil and tonumber(pricePerLiter) then
			FillUtil.fillTypeIndexToDesc[desc.index].pricePerLiter = tonumber(pricePerLiter);
			local previousHourPrice = FillUtil.fillTypeIndexToDesc[desc.index].previousHourPrice;
			if tonumber(previousHourPrice) == 0 or previousHourPrice == nil then								
				FillUtil.fillTypeIndexToDesc[desc.index].previousHourPrice = tonumber(pricePerLiter);
			end;
			local startPricePerLiter = FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter;
			if tonumber(startPricePerLiter) == 0 or startPricePerLiter == nil then								
				FillUtil.fillTypeIndexToDesc[desc.index].startPricePerLiter = tonumber(pricePerLiter);
			end;
		end;			
		if stationsUpdate then moSetGetStationes:setStationUpdate(self, true, nil);end;
	elseif delete then
		if moGeneralSettings.replaceStationsTrigger[stationName] == nil then moGeneralSettings.replaceStationsTrigger[stationName] = {};moGeneralSettings.replaceStationsTrigger[stationName].name = tostring(stationName);moGeneralSettings.replaceStationsTrigger[stationName].deleteFruits = {};moGeneralSettings.replaceStationsTrigger[stationName].setFruits = {};end;		
		moGeneralSettings.replaceStationsTrigger[stationName].deleteFruits[fruitDescName] = {fruitName=tostring(fruitDescName)};
		if moGeneralSettings.replaceStationsTrigger[stationName].setFruits[fruitDescName] ~= nil then
			moGeneralSettings.replaceStationsTrigger[stationName].setFruits[fruitDescName] = nil;
		end;
		deleteFruits(tipTrigger, fruitDescName);
		if stationsUpdate then moSetGetStationes:setStationUpdate(self, true, nil);end;
	end;	
end;

function moGuiExtras:setTriggerNew(self, hofSilo, unLoad, objectTable, descIndex, descName)
	local farmSilo = moGeneralSettings.multiFarmSilo;
	if hofSilo then
		if unLoad then
			local replacePDA = moGeneralSettings.multiFarmSiloUnLoad;
			local desc = FillUtil.fillTypeNameToDesc[descName];
			if desc == nil then return;end;
			if string.find(moGeneralSettings.multiFarmSiloUnLoad, descName.. " ") then				
				moGeneralSettings.multiFarmSiloUnLoad = string.gsub(replacePDA, descName.. " ", "");
				objectTable.acceptedFillTypes[desc.index] = nil;
				moFillTypes[desc.index].siloUnLoad[farmSilo] = false;
			else
				moGeneralSettings.multiFarmSiloUnLoad = moGeneralSettings.multiFarmSiloUnLoad.. tostring(descName).. " ";
				objectTable.acceptedFillTypes[desc.index] = true;
				moFillTypes[desc.index].siloUnLoad[farmSilo] = true;
				if descName == "silage" then
					FillUtil.fillTypeIndexToDesc[desc.index].notInStorage = false;
				end;
			end;
		else
			local replacePDA = moGeneralSettings.multiFarmSiloLoad;
			local toInt = FillUtil.fillTypeNameToInt[descName];
			local desc = FillUtil.fillTypeNameToDesc[descName];
			if desc == nil then return;end;
			if string.find(moGeneralSettings.multiFarmSiloLoad, descName.. " ") then				
				moGeneralSettings.multiFarmSiloLoad = string.gsub(replacePDA, descName.. " ", "");
				objectTable.fillTypes[toInt] = nil;
				moFillTypes[toInt].siloLoad[farmSilo] = false;
			else
				moGeneralSettings.multiFarmSiloLoad = moGeneralSettings.multiFarmSiloLoad.. tostring(descName).. " ";
				objectTable.fillTypes[toInt] = toInt;
				moFillTypes[toInt].siloLoad[farmSilo] = true;				
			end;
		end;
	end;
end;

function moGuiExtras:getUtf8normalization()
	local result = {};
	local normalizationSpans = {
		a  = { {192,195}, 197, {224,227}, 229, {256,261} },
		ae = { 196, 198, 228, 230 },
		c  = { 199, 231, {262,269} },
		d  = { {270,273} },
		e  = { {200,203}, {232,235}, {274,283} },
		g  = { {284,291} },
		h  = { {292,295} },
		i  = { {204,207}, {236,239}, {296,307} },
		j  = { {308,309} },
		k  = { {310,312} },
		l  = { {313,322} },
		n  = { 209, 241, {323,331} },
		o  = { {210,213}, {242,245}, {332,337} },
		oe = { 214, 216, 246, 248, 338, 339 },
		r  = { {340,345} },
		s  = { {346,353}, 383 },
		ss = { 223 },
		t  = { {354,359} },
		u  = { {217,219}, {249,251}, {360,371} },
		ue = { 220, 252 },
		w  = { 372, 373 },
		y  = { 221, 253, 255, {374,376} },
		z  = { {377,382} }
	};
	for normal,unicodes in pairs(normalizationSpans) do
		for _,data in pairs(unicodes) do
			if type(data) == "number" then
				local utf8 = unicodeToUtf8(data);
				result[utf8] = normal;
				if false and getCanRenderUnicode(data) then
					--print(string.format("MultiOverlayV2.utf8normalization[%q] = %q", utf8, normal));
				end;
			elseif type(data) == "table" then
				for unicode=data[1],data[2] do
					local utf8 = unicodeToUtf8(unicode);
					result[utf8] = normal;
					if false and getCanRenderUnicode(unicode) then
						--print(string.format("MultiOverlayV2.utf8normalization[%q] = %q", utf8, normal));
					end;
				end;
			end;
		end;
	end;
	return result;
end;

function moGuiExtras:onIsUnicodeAllowed(unicode)
	return MultiOverlayV2.allowedCharacters[unicode] == true;
end;

moGuiExtras.colors = {		
	darkYellow =   		{ 255/255, 161/255,  17/255, 1.00 };
	darkYellowOff =  	{ 255/255, 161/255,  17/255, 0.80 };
	white =         	{ 255/255, 255/255, 255/255, 1.00 };
	whiteBestPrice =	{ 255/255, 255/255, 255/255, 1.00 };
	whiteInactive = 	{ 255/255, 255/255, 255/255, 0.75 };
	whiteDisabled = 	{ 255/255, 255/255, 255/255, 0.15 };
	hover =         	{   4/255,  98/255, 180/255, 1.00 };
	hoverBestPrice =	{   4/255,  98/255, 180/255, 0.70 };
	darkBlue =	 		{ 	0/255,   0/255, 255/255, 1.00 };
	activeGreen =   	{  43/255, 205/255,  10/255, 1.00 }; 
	activeRed =    	 	{ 153/255,  22/255,  19/255, 1.00 }; 
	closeRed =      	{ 116/255,   0/255,   0/255, 1.00 }; 
	warningRed =    	{ 222/255,   2/255,   3/255, 1.00 };
	red =      			{ 255/255,   0/255,   0/255, 1.00 };
	redDisabled =   	{ 255/255,   0/255,   0/255, 0.80 };
	shadow =        	{   4/255,   4/255,   4/255, 1.00 }; 
	textDark =      	{   1/255,   1/255,   1/255, 1.00 };
	yellow =        	{ 255/255, 255/255,   0/255, 1.00 };
	yellowDisabled =	{ 255/255, 255/255,   0/255, 0.80 };
	yellowGreen =		{ 154/255, 205/255,  50/255, 1.00 };
	yellow1 =			{ 238/255, 221/255, 130/255, 1.00 };
	gold =				{ 255/255, 215/255,   0/255, 1.00 };
	green =        		{ 	0/255, 255/255,   0/255, 1.00 };
	darkOliveGreen =    {  85/255, 107/255,  47/255, 1.00 };
	greenDisabled = 	{ 	0/255, 255/255,   0/255, 0.80 };
	darkGreen = 		{ 	0/255, 100/255,   0/255, 1.00 };
	lightGreen =   		{ 144/255, 238/255, 144/255, 1.00 };
	chartreuse4 =		{ 69/255,  139/255,   0/255, 1.00 };
	happylooser =   	{ 143/255, 188/255, 143/255, 1.00 };---
	happylooserOff= 	{ 143/255, 188/255, 143/255, 0.80 };---
	gray = 				{ 190/255, 190/255, 190/255, 1.00 };
	black =        		{ 	0/255,   0/255,   0/255, 1.00 };
	orange =        	{ 255/255, 165/255,   0/255, 1.00 };
	orangeRed =        	{ 255/255,  55/255,   0/255, 1.00 };
	khaki =         	{ 240/255, 230/255, 140/255, 1.00 };
	ls15 =          	{   0/255, 255/255, 255/255, 1.00 };
	ls15Disabled =  	{   0/255, 255/255, 255/255, 0.80 };
	mangenta =  		{ 255/255, 	 0/255, 255/255, 1.00 };
	deepPink =  		{ 255/255, 020/255, 147/255, 1.00 };
	purple =  			{ 160/255, 032/255, 240/255, 1.00 };
};